import threading
import os

class Dispatcher:

    threads = []
    callbackExecutor = None
    extensionFilter = None

    def __init__(self, callbackExecutor):
        self.callbackExecutor = callbackExecutor

    def apply_filter(self, audio_file):
        # TODO: return True if audio file is valid, based on name, extension, and other criteria
        if os.path.isdir(audio_file):
            return False
        return True

    def execute(self, audio_file):
        if self.apply_filter(audio_file.pathname):
            self.threads.append(threading.Thread(target=self._execute_thread, args=(audio_file.pathname,)))
            self.threads[-1].start()
            # TODO: we need to have a way to wipe old threads, otherwise we will have a memory leak

    def _execute_thread(self, audio_file):
        self.callbackExecutor.execute(audio_file)