import pyinotify

class EventHandler(pyinotify.ProcessEvent):
    def process_IN_CREATE(self, event):
        print(f'New file: {event.pathname}')
        return event.pathname

class Picker:

    directory = None
    callbackObject = None

    def __init__(self, directory, callbackObject):
        self.directory = directory
        self.callbackObject = callbackObject

    def observe(self):
        wm = pyinotify.WatchManager()
        notifier = pyinotify.Notifier(wm, EventHandler())
        wm.add_watch(self.directory, pyinotify.IN_CREATE, self.callbackObject.execute)

        print(f'Watching {self.directory} for changes...')
        notifier.loop()
